/**
 * $Revision: 51691 $
 * $Date: 2017-07-24 14:30:23 +0000 (Mon, 24 Jul 2017) $
 * Do not edit manually. It is generated by SVN.
 */


// Uncomment to test without redirection to https
var TEST_LOCALLY = false;

/**
 * Operation OS name/type. Example "Linux"
 * @type {String}
 * @private
 */
var DEVICE_OS = null;
/**
 * Platform/scheme name. Example: "pc" or "synology"
 * @type {String}
 * @private
 */
var DEVICE_PLATFORM = null;
/**
 * Application type. Can be "native" (for native clients) or "canvas" (for web)
 * @type {String}
 * @private
 */
var APP_TYPE = null;
/**
 * Activation code parsed from parameter "code". Can be null if no parameter
 *
 * @type {String}
 * @private
 */
var CODE_ACTIVATE = null;
/**
 * mspId parsed from parameter "mspId". Can be null if no parameter
 *
 * @type {String}
 * @private
 */
var MSP_ID = null;

/**
 * caps parsed from parameter "caps". Can be null if no parameter
 *
 * @type {String}
 * @private
 */
var CAPS = null;

/**
 * alias parsed from parameter "alias". Can be null if no parameter
 *
 * @type {String}
 * @private
 */
var ALIAS = null;

/**
 * Error container id for errors from form
 * @type {string}
 * @constant
 */
var MSG_ID = "updatemsgForm";

var ERROR_OK = 0;

var ERROR_LOGIN = 1001;
var ERROR_NOT_CONNECTED = 1002;
var ERROR_TIME_OUT = 1003;
var ERROR_INVALID_CODE = 1004;
var ERROR_UNKNOWN = 1005;
var PASSIVE_IS_DOWN = 1006;
var SHARE_ID_EXIST = 1007;
var ERROR_SEND_LOGS = 1008;

var ERROR_SHARE = 5001;
var ERROR_SHARE_FAILED_TO_START = 5002;
var ERROR_INTERNAL_SERVER = 5003;
var ERROR_JSON_PARSE_FAILED = 5004;
var ERROR_AJAX_REQUEST_ABORTED = 5005;

function isSecured() {
    var proto = document.location.protocol;
    return TEST_LOCALLY ? true : proto === 'https:';
}

/**
 * Parse URL parameters and call {@link setGlobals}.
 * @return {Object} key/value map with all URL parameters.
 */
function parseParams() {
    var listParam = {};
    // Parse from URL and override
    var query = decodeURIComponent(window.location.search.substring(1));
    var listRaw = query.split('&');
    for (var i = 0; i < listRaw.length; i++) {
        var param = listRaw[i].split('=');
        if (param[0] && param[1]) {
            listParam[param[0]] = param[1];
        }
    }
    return listParam;
}

function initializeLanguage(path, cb) {
    var options = {
        resGetPath: path,
        lowerCaseLng: true,
        detectLngQS: 'lang',
        useCookie: false,
        fallbackLng: 'en',
        ns: 'admin',
        debug: true,
        escapeInterpolation: false
    };
    i18n.init(options, function(t) {
        // translate our HTML
        log("translating html head");
        $("head").i18n();
        log("translating html body");
        $("body").i18n();
        if (cb)
            cb();
    });
}


function generateSecuredUrl() {
    var pathname = window.location.pathname;
    var search = window.location.search;
    var hash = window.location.hash;
    var hostname= window.location.hostname;
    var newUrl = "https://" + hostname + ":" + HTTPS_PORT + pathname + search + hash;
    return newUrl;
}


function addParams(url, params) {
    var isFirst = true;
    for (var key in params) {
        if (Object.prototype.hasOwnProperty.call(params, key)) {
            var value = params[key];
            if (isFirst) {
                isFirst = false;
                url += "?";
            } else {
                url += "&";
            }
            var valueEnc = encodeURIComponent(value);
            url += key + "=" + valueEnc;
        }
    }
    return url;
}


/**
 * Init DEVICE_OS, DEVICE_PLATFORM and APP_TYPE global variables from given parameters.
 * Expected keys: "os", "platform" and "type"
 *
 * @param {Object} listParam
 */
function setGlobals(listParam) {
    jQuery.each(listParam, function (key, value) {
        if (key && value) {
            key = key.toLowerCase();
            value = ("" + value).toLowerCase();
            switch (key) {
                case "os":
                    // Normalize some
                    switch (value) {
                        case "darwin":
                        case "macintosh":
                            value = "mac";
                            break;
                    }
                    DEVICE_OS = value;
                    break;
                case "platform":
                    DEVICE_PLATFORM = value;
                    break;
                case "type":
                    APP_TYPE = value;
                    break;
                case "code":
                    CODE_ACTIVATE = value;
                    break;
                case "mspid":
                    MSP_ID = value;
                    break;
                case "caps":
                    CAPS = value;
                    break;
                case "alias":
                    ALIAS = value;
                    break;
            }
        }
    });
    log("Parse OS=" + DEVICE_OS + ", Platform=" + DEVICE_PLATFORM +", AppType=" + APP_TYPE +", MSP ID=" + MSP_ID +", CAPS=" + CAPS+", ALIAS=" + ALIAS);

    // Hide main header if there is caps parameter with value notoptoolbar
    if (CAPS === "notoptoolbar") {
        $(".headerCont").hide();
    }

    // Add alias class in the body for special styling
    if (ALIAS != "null") {
        $("body").addClass(ALIAS);
    }

    // Add platform class in homepage device logo if there is platform
    if (DEVICE_PLATFORM != "null") {
        $(".aliasLogo").addClass(DEVICE_PLATFORM);
    }
}


/**
 *
 * @param {String} idComp ID of component to which to set string.
 * Same string ID must exist in language files.
 */
function setTextContext(idComp) {

    var idStr = idComp;
    if (DEVICE_OS)
        idStr += "_" + DEVICE_OS;
    if (DEVICE_PLATFORM)
        idStr += "_" + DEVICE_PLATFORM;
    if (!i18n.exists(idStr)) {
        //log("Missing string " + idStr + ", will use " + idComp, true);
        idStr = idComp;
    }
    var str = i18n.t(idStr);
    //log("Set string " + idStr + ": " + str + " to component: " + idComp);
    $("#" + idComp).html(str);

    // special cases requirements
    if (DEVICE_OS=="linux" && DEVICE_PLATFORM=="tplink") {
        getComp(USERNAME_FIELD_CLASS).val("root"); // add "root" as username
        getComp(USERNAME_FIELD_CLASS).attr('readonly', true); // set username field as readonly
        getComp("user-domain-group").css("display","none"); // remove domain section
    }
}

var _LIST_IMAGE = {
    "scrUsername": "scr_username.jpg",
    "scrPassword": "scr_password.jpg",
    "scrDomain": "scr_domain.jpg",

    "scrUsername_windows_pc": "scr_username.jpg",
    "scrPassword_windows_pc": "scr_password.jpg",
    "scrDomain_windows_pc": "scr_domain.jpg",
    "scrUsername_windows_network": "scr_username.jpg",
    "scrPassword_windows_network": "scr_password.jpg",
    "scrDomain_windows_network": "scr_domain.jpg",

    "scrUsername_mac_pc": "scr_username_mac_pc.jpg",
    "scrPassword_mac_pc": "scr_password_mac_pc.jpg",
    "scrDomain_mac_pc": "scr_domain_mac_pc.jpg",

    "scrUsername_linux_pc": "scr_username_linux_pc.jpg",
    "scrPassword_linux_pc": "scr_password_linux_pc.jpg",
    "scrDomain_linux_pc": "scr_domain_linux_pc.jpg",
    "scrUsername_linux_synology": "scr_username_synology.jpg",
    "scrPassword_linux_synology": "scr_password_synology.jpg",
    "scrDomain_linux_synology": "scr_empty.png",
    "scrUsername_linux_qnap": "scr_username_qnap.jpg",
    "scrPassword_linux_qnap": "scr_password_qnap.jpg",
    "scrDomain_linux_qnap": "scr_empty.png",
    "scrUsername_linux_drobo": "scr_username_drobo.jpg",
    "scrPassword_linux_drobo": "scr_password_drobo.jpg",
    "scrDomain_linux_drobo": "scr_empty.png",
    "scrUsername_linux_netgear": "scr_username_netgear.jpg",
    "scrPassword_linux_netgear": "scr_password_netgear.jpg",
    "scrDomain_linux_netgear": "scr_empty.png",
    "scrUsername_linux_overland": "scr_username_overland.jpg",
    "scrPassword_linux_overland": "scr_password_overland.jpg",
    "scrDomain_linux_overland": "scr_empty.png",
    "scrUsername_linux_tplink": "scr_username_tplink.jpg",
    "scrPassword_linux_tplink": "scr_password_tplink.jpg",
    "scrDomain_linux_tplink": "scr_empty.png",
    "scrUsername_linux_asustor": "scr_username_asustor.jpg",
    "scrPassword_linux_asustor": "scr_password_asustor.jpg",
    "scrDomain_linux_asustor": "scr_empty.png"
};


/**
 *
 * @param {String} idComp ID of component to which to set image to.
 * Same image ID must exist in list with allowed images.
 */
function setImageContext(idComp) {
    var idImg = idComp;
    var $comp = $("#" + idComp);
    if (DEVICE_OS)
        idImg += "_" + DEVICE_OS;
    if (DEVICE_PLATFORM)
        idImg += "_" + DEVICE_PLATFORM;
    if (_LIST_IMAGE[idImg] == "scr_empty.png") {
        $comp.css("display", "none");
    }
    if (!_LIST_IMAGE[idImg]) {
        log("Missing image " + idImg+ ", will use " + idComp);
        idImg = idComp;
    }
    if (!_LIST_IMAGE[idImg]) {
        log("Missing image for component: " + idComp);
        return;
    }
    //log("Set image for component: " + idComp + "=" + idImg);
    $comp.attr("src", "images/" + _LIST_IMAGE[idImg]);
}

/**
 * Get component with given class and context
 *
 * @param {String} compClass  class of component
 * @param {jQuery} [$context] context of component.
 * If null or omitted will used default context (HTML from element)
 * @return {jQuery}
 */
function getComp(compClass, $context) {
    if(!$context || $context.length <= 0)
        $context = $("form");
    return $("." + compClass, $context);
}

function switchTT() {
    var $comp = $(this).parent();
    $comp.parent().find(".tooltipCont").css("display", "none");
    $comp.find(".tooltipCont").css("display", "inline-block");
}

function addFocusHandler(idComp, toFocus) {
    var $comp = $("#" + idComp);
    $comp.focus(switchTT);
    if (toFocus)
        $comp.focus();

}

/**
 *
 * @param {String} strId
 * @param {Object} [args]
 * @return {String}
 */
function getLocaleStr(strId, args) {
    return $.t(strId, args);
}

/**
 * Render the status in terms of a message, and highlighting errors
 *
 * @param {Number} errorCode
 * @param {String} strId
 */
function showMessage(errorCode, strId) {
    var msg = getLocaleStr(strId);
    var $errorMsgCont = $("#" + MSG_ID);
    // remove previous errors using jquery - search for alerts? it will do
    getComp("alert", $errorMsgCont).remove();

    var $actGr = getComp("activation-group");
    var $passGr = getComp("user-password-group");
    var $nameGr = getComp("user-name-group");
    var $domainGr = getComp("user-domain-group");
    // remove errors first from all groups
    $actGr.removeClass("has-error");
    $passGr.removeClass("has-error");
    $nameGr.removeClass("has-error");
    $domainGr.removeClass("has-error");

    // add the error/success message and highlights
    if (errorCode != ERROR_OK) {
        var isShowRetryLink = false;
        switch (errorCode) {
            case ERROR_LOGIN:
                $nameGr.addClass("has-error");
                $passGr.addClass("has-error");
                $domainGr.addClass("has-error");
                break;
            case ERROR_INVALID_CODE:
                isShowRetryLink = true;
                $actGr.addClass("has-error");
                break;
            default:
                break;
        }

        var $error = $("<div class='alert alert-danger'>" + msg + "</div>");
        $errorMsgCont.prepend($error);

        // show the retry link
        if (isShowRetryLink && retryLink) {
            $("<a class='retryLink'></a>").attr("href", retryLink).text(getLocaleStr("retry_link")).appendTo($error);
        }
    } else {
        $errorMsgCont.prepend("<div class='alert alert-success'>" + msg + "</div>");
    }
}

/**
 *
 * @param xhr
 * @param err
 * @return {number}
 */
function getError(xhr,err) {
    if (xhr.status === 0) {
        return ERROR_NOT_CONNECTED;
    } else if (xhr.status > 300) {
        return ERROR_INTERNAL_SERVER;
    } else if (err === 'parsererror') {
        return ERROR_JSON_PARSE_FAILED;
    } else if (err === 'timeout') {
        return ERROR_TIME_OUT;
    } else if (err === 'abort') {
        return ERROR_AJAX_REQUEST_ABORTED;
    } else {
        return ERROR_UNKNOWN;
    }
}

/**
 * Parse response error message to error code
 * @param {String} msg
 * @return {String}
 */
function translateMsgToErrorCode(msg) {
    var code;
    switch (msg) {
        case "Share failed to start":
            code = ERROR_SHARE_FAILED_TO_START;
            break;
        case "User validation failed":
            code = ERROR_LOGIN;
            break;
        case "Share not found":
            code = ERROR_SHARE;
            break;
        default:
            code = ERROR_UNKNOWN;
            break;
    }

    return code;
}

/**
 * Parse error code to correct error string id
 * @param {Number} [code]
 */
function translateErrorCode(code) {
    var strId;
    switch (code) {
        case ERROR_OK:
            strId = "activate_error_ok";
            break;
        case ERROR_LOGIN:
            strId = "error_invalid_credentials"; // failure - the credentials
            break;
        case ERROR_NOT_CONNECTED:
        case ERROR_TIME_OUT: // server HTTP connections timeout, etc
            strId = "error_communication";
            break;
        case ERROR_INVALID_CODE: // any code-related problem
            strId = "error_invalid_code";
            break;
        case ERROR_INTERNAL_SERVER:
            strId = "error_internal_server";
            break;
        case ERROR_JSON_PARSE_FAILED:
            strId = "error_json_parse_failed";
            break;
        case ERROR_AJAX_REQUEST_ABORTED:
            strId = "error_ajax_request_aborted";
            break;
        case ERROR_SHARE:
            strId = "error_invalid_share"; // failure - the share
            break;
        case ERROR_SHARE_FAILED_TO_START:
            strId = "error_share_failed_to_start"; // fail to start - the share
            break;
        case PASSIVE_IS_DOWN:
        case SHARE_ID_EXIST:
            strId = "error_unknown_exception";
            break;
        default :
            code = ERROR_UNKNOWN;
            strId = "error_unknown_exception"; // unknown failure - assume the code
            break;
    }

    if(strId)
        showMessage(code, strId); // unknown failure - assume the code
}

/**
 * Handles click of the main Cancel button which suppose to return back to the main application
 */
function onReturnToApp() {
    log("Cancel is requested appType=" + APP_TYPE);
    if (APP_TYPE === "native") {
        window.open("qnext://client/_SWITCH_TO_MAIN");
    } else {
        history.back();
    }
}

// extract a parameter from URL, or return empty string if it doesn't exist
function gup( name ) {
    name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
    var regexS = "[\\?&]"+name+"=([^&#]*)";
    var regex = new RegExp( regexS );
    var results = regex.exec( window.location.href );
    if( results == null )
        return "";
    else
        return decodeURIComponent(results[1]);
}

function log(text, isWarn) {
    if (console) {
        if (isWarn === true)
            console.warn(text);
        else
            console.log(text);
    }
}

// Init global settings from parameters
setGlobals(parseParams());
