/**
 * Copyright Qnext Inc. 2002-2016
 * http://www.qnext.com
 * Date: 17.02.2016
 * Time: 12:30
 * Author Milen Dimitrov (milen.d@komero.net)
 */

var _PAGE_ACTIVATE = "activate";
var _PAGE_HOME = "home";

$(document).ready(function() {

    function updatePage() {
        var hash = location.hash && location.hash.charAt(0) === "#" ? location.hash.substring(1) : null;
        var page;
        if (hash) {
            // If there is a hash - use it
            page = hash;
        } else if (CODE_ACTIVATE) {
            // If no hash - check is there code, then use it
            page = _PAGE_ACTIVATE;
        } else {
            // Finally fallback to home page
            page = _PAGE_HOME;
        }
        console.log("Change page: " + page);
        var isActivate = page === _PAGE_ACTIVATE;
        $("#pageHome").toggle(!isActivate);
        $("#pageActivate").toggle(isActivate);

        if (isActivate) {
            startActivate();
        } else {
            psvFetchStatus();
        }
    }

    // Hide initially both pages until languages are loaded
    $("#pageHome").hide();
    initializeLanguage("locales/__ns__-__lng__.json", function() {
        $(window).on("hashchange", updatePage);
        updatePage();
    });

    // capitalization function - more complicated than using keyup, but does not have a visual change, and more
    // complicated than using css uppercase + toUpper on submit, but does not affect the default state suggestion text.
    getComp(CODE_FIELD_CLASS).on("keydown", function (e) {
        var input = $(this);

        // track the initial cursor position
        var start = input[0].selectionStart;
        var end = input[0].selectionEnd;

        // skip processing if control/alt/command are pressed
        if (!e.ctrlKey && !e.altKey) {
            // avoid backspace 8, tab 9, enter 13, arrow keys 37-40
            if ($.inArray(event.keyCode, [8, 9, 13, 37, 38, 39, 40]) === -1) {
                $(this).val(function (i, val) {
                    var leftPart = val.substring(0, start);
                    var rightPart = val.substring(end);
                    return leftPart + String.fromCharCode(event.keyCode).toUpperCase() + rightPart;
                });

                // adjust the cursor position
                input[0].selectionStart = input[0].selectionEnd = start + 1;
                return false;
            }
        }
    });


    /**
     * Activation submit button pressed
     */
    $("#" + ACTIVATION_ID).submit(function (e) {
        e.preventDefault();
        var code = getComp(CODE_FIELD_CLASS).val();
        var userName = getComp(USERNAME_FIELD_CLASS).val();
        var userPassword = getComp(PASSWORD_FIELD_CLASS).val();
        var userDomain = getComp(DOMAIN_FIELD_CLASS).val();
        // get from common.js
        var mspId = MSP_ID;

        activeButtonOnOff(true);

        // validate the code and render errors if necessary
        if (!validateCode(code, function (msg) {
                activeButtonOnOff(false);
                showMessage(ERROR_INVALID_CODE, msg);
            })) return;

        // proceed with the activation attempt
        psvRegisterCode(code, userName, userPassword, userDomain, mspId);
    });
});


