//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// CONTROLLERS AND GLOBALS
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

var defaultDomainPanel = new DefaultDomainPanel("#defaultDomain");
var alertsPanel = new AlertsPanel("#alerts");
var storagePanel = new StoragePanel("#revisionStorage");
var hostOverridePanel = new HostOverridePanel("#hostOverride");

$(document).ready(function() {
    initializeLanguage(function() {
        initializeViews();
        protocolFetchStatus(model, function() {
            console.log("status fetch complete");
        });
    });
});

function subscribeToModelEvents(eventNames, subscriber) {
    for (var t=0; t<eventNames.length; t++) {
        var eventName = eventNames[t];
        $(document).on(eventName, subscriber, subscriber.ffModelChanged);
    }
}

function initializeLanguage(cb) {
    var options = {
        resGetPath: '/locales/__ns__-__lng__.json',
        lowerCaseLng: true,
        detectLngQS: 'lang',
        useCookie: false,
        fallbackLng: 'en',
        ns: 'admin',
        debug: true
    };
    i18n.init(options, function(t) {
        // translate our HTML
        console.log("translating html head");
        $("head").i18n();
        console.log("translating html body");
        $("body").i18n();
        cb();
    });
}

function initializeViews() {
    // initialize panels, and subscribe them to their requested model events
    subscribeToModelEvents(hostOverridePanel.getModelEventsHandled(), hostOverridePanel);
    subscribeToModelEvents(defaultDomainPanel.getModelEventsHandled(), defaultDomainPanel);
    subscribeToModelEvents(alertsPanel.getModelEventsHandled(), alertsPanel);
    subscribeToModelEvents(storagePanel.getModelEventsHandled(), storagePanel);
}
