//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// MODEL
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

var modelEvents = {
    REVISION_ROOT_CHANGED:"ff_revision_root_changed",
    HOST_OVERRIDE_CHANGED:"ff_host_override_changed",
    DEFAULT_DOMAIN_CHANGED:"ff_default_domain_changed",
    REVISION_CAPACITIES_CHANGED:"ff_revision_capacities_changed",
    VERSION_CHANGED:"ff_version_changed",
    CAN_UPDATE_CHANGED:"ff_can_update_changed"
};

var model = {
    // private members - do not update directly!
    revisionRoot:"/",
    hostOverride:"",
    defaultDomain:"",
    revisionSpaceFree:0,
    revisionSpaceCapacity:0,
    version:"0.0.0.0",
    canUpdate:false,
    build:"",

    // update the revision root
    updateRevisionRoot : function(newRoot) {
        this.revisionRoot = newRoot;
        $.event.trigger(modelEvents.REVISION_ROOT_CHANGED, [model]);
    },

    // update the host override
    updateHostOverride : function(newHost) {
        this.hostOverride = newHost;
        $.event.trigger(modelEvents.HOST_OVERRIDE_CHANGED, [model]);
    },

    // update the default domain
    updateDefaultDomain : function(newDomain) {
        this.defaultDomain = newDomain;
        $.event.trigger(modelEvents.DEFAULT_DOMAIN_CHANGED, [model]);
    },

    // update the revision capacities
    updateRevisionCapacities : function(newSpaceFree, newSpaceCapacity) {
        this.revisionSpaceCapacity = newSpaceCapacity;
        this.revisionSpaceFree = newSpaceFree;
        $.event.trigger(modelEvents.REVISION_CAPACITIES_CHANGED, [model]);
    },

    // update the version information
    updateVersion : function(newVersion, newBuild) {
        this.version = newVersion;
        this.build = newBuild;
        $.event.trigger(modelEvents.VERSION_CHANGED, [model]);
    },

    // update the can-update flag
    updateCanUpdate : function(newCanUpdate) {
        this.canUpdate = newCanUpdate;
        $.event.trigger(modelEvents.CAN_UPDATE_CHANGED, [model]);
    }
};
