//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// VIEW - ALERTS PANEL (can update display)
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function AlertsPanel(id) {
    console.log("AlertsPanel.constructor");
    // mandatory call to parents constructor
    AlertsPanel.prototype.parentConstructor.apply(this, arguments);
}

extend(AlertsPanel, BasePanel);

AlertsPanel.prototype.getModelEventsHandled = function(e) {
    console.log("AlertsPanel.getModelEventsHandled");
    return [modelEvents.CAN_UPDATE_CHANGED];
};

AlertsPanel.prototype.handleModelChanged = function(type, data) {
    console.log("AlertsPanel.handleModelChanged");
    switch(type) {
        case modelEvents.CAN_UPDATE_CHANGED:
            this.render(data);
    }
};

AlertsPanel.prototype.addAlert = function(msg, type, title) {
    if (type == null) type = "warning";
    if (title == null) {
        $("#alerts").append("<div class='alert alert-" + type + "'>" + msg + "</div>");
    } else {
        var html = "<div class='panel panel-" + type + "'>";
        html = html + "<div class='panel-heading'>" + title + "</div>";
        html = html + "<div class='panel-body'>" + msg + "</div></div>";
        $("#alerts").append(html);
    }
};

AlertsPanel.prototype.render = function(model) {
    if (!model.canUpdate) {
        var body = $.t("updates_disabled_body");
        var title = $.t("updates_disabled_title");
        this.addAlert(body, "danger", title);
    }
};
