//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// VIEW - DEFAULT DOMAIN
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function DefaultDomainPanel(id) {
    console.log("DefaultDomainPanel.constructor");
    // mandatory call to parents constructor
    DefaultDomainPanel.prototype.parentConstructor.apply(this, arguments);

    // bind the update button click
    this.bind(this.panelId + ' .btn', "click", this.handleUpdateClick);
}

extend(DefaultDomainPanel, BasePanel);

DefaultDomainPanel.prototype.handleUpdateClick = function(e) {
    var self = this;
    this.ffConfirm($.t("default_domain_confirmation"), function(e) {
        var newValue= $(self.panelId + ' input[type=text]').val();
        protocolSetDefaultDomain(newValue, function() {
            console.log("set host override to " + newValue);
            self.showInputAlert(true, $.t("default_domain_success", {domain: newValue}));
        }, function() {
            self.showInputAlert(false, $.t("default_domain_failure"));
        });
    });
};

DefaultDomainPanel.prototype.getModelEventsHandled = function(e) {
    console.log("DefaultDomainPanel.getModelEventsHandled");
    return [modelEvents.DEFAULT_DOMAIN_CHANGED];
};

DefaultDomainPanel.prototype.handleModelChanged = function(type, data) {
    console.log("DefaultDomainPanel.handleModelChanged");
    switch(type) {
        case modelEvents.DEFAULT_DOMAIN_CHANGED:
            this.render(data);
    }
};

DefaultDomainPanel.prototype.render = function(model) {
    $(this.panelId + ' input[type=text]').val(model.defaultDomain);
};
